#include <string>

#include <Tracer.h>
#include <Dal.h>
#include <errstr.h>

#include "SasDalUtils.h"

// the following based on code by U. Lammers

string SasDalUtils::getStringColumnRow(const ColumnData *c, unsigned long row)
{
  PROC
  unsigned long len = c->size()[0];
  if ((c->stringData() + c->position(row) + len - 1)[0] != '\0') {
    char s[len+1];
    strncpy(s, c->stringData() + c->position(row), len);
    s[len] = '\0';
    ALTRETURNV(string(s));
  }

  RETURN string(c->stringData() + c->position(row));
}

void SasDalUtils::setStringColumnRow(const ColumnData *c, const unsigned long row, const string &str)
{
  PROC
    
  unsigned long len = c->size()[0];
  strncpy(c->stringData() + c->position(row), str.c_str(), len);
  
  ENDPROC
}

void SasDalUtils::finalize(const DataSet *s)
{
  PROC
  Sas::warning("NotImplemented", "finalizeSet not yet implemented: " + s->name());
  ENDPROC
}
