#include <f90cxx.h>
#include <Handle.h>
#include <Tracer.h>
#include <EventAttributes.h>
#include <errstr.h>
#include <cmath>
#include <cassert>

F90MODPROCDEF(void,eventattributes,seteventattribute)(
	      Handle<Table> & tableH,
	      const int & mask)
{
  PROC
  // Messy
  for(int i = 0; i < static_cast<int>(EventAttributes::NUMBER_OF); i++)
    if((mask & (1 << i)))
      EventAttributes::setEventAttribute(tableH.addressOfObject(), static_cast<EventAttributes::EvAtt>(i));
  ENDPROC
}

F90MODPROCDEF(void,eventattributes,copyeventattributes)(
	      const Handle<Table> & fromtableH,
	      Handle<Table> & totableH)
{
  PROC
  EventAttributes::copyEventAttributes(fromtableH.addressOfObject(),totableH.addressOfObject());
  ENDPROC
}

F90MODPROCDEF(void,eventattributes,setemosrejectionmask)(
	      Handle<Table> & tableH)
{
  PROC
  EventAttributes::setEmosRejectionMask(tableH.addressOfObject());
  ENDPROC
}

F90MODPROCDEF(void,eventattributes,setepnrejectionmask)(
	      Handle<Table> & tableH)
{
  PROC
  EventAttributes::setEpnRejectionMask(tableH.addressOfObject());
  ENDPROC
}

F90MODPROCDEF(void,eventattributes,setrgsrejectionmask)(
	      Handle<Table> & tableH)
{
  PROC
  EventAttributes::setRgsRejectionMask(tableH.addressOfObject());
  ENDPROC
}

// SCR 198
F90MODPROCDEF(void,eventattributes,setemosspectralmask)(
	      Handle<Table> & tableH)
{
  PROC
  EventAttributes::setEmosSpectralMask(tableH.addressOfObject());
  ENDPROC
}


F90MODPROCDEF(bool,eventattributes,eventattributeisset)(
	      const Handle<Table> & tableH,
	      const int & mask)
{
  PROC

  assert(mask == 1 || !(mask % 2));
//       #include <math.h>

//       double frexp(double num, int *exp);

//  DESCRIPTION
//       The frexp() function breaks a floating-point number  into  a
//       normalised  fraction  and an integral power of 2.  It stores
//       the integer exponent in the int object pointed to by exp.

//  RETURN VALUES
//       The frexp() function returns the value x, such that x  is  a
//       double with magnitude in the interval [1/2, 1) or 0, and num
//       equals x times 2 raised to the power *exp.

  int n;
  frexp(double(mask), &n);
  // The return value (here ignored) of frexp() is always 1/2 for powers
  // of 2, so 1 must be subtracted from n.
  RETURN EventAttributes::eventAttributeIsSet(tableH.addressOfObject(), static_cast<EventAttributes::EvAtt>(n-1));
}
