//
// Class representing directory entries
//
// Giuseppe Vacanti, European Space Agency, 1999
//
#ifndef DirEntryImplementation_H
#define DirEntryImplementation_H

#include <string>
#include <sys/types.h>

#include "DirEntry.h"

class DirEntryImplementation : public virtual DirEntry {

 public:

  DirEntryImplementation();
  DirEntryImplementation(const string name);

  virtual string name() const;
  virtual string dirname() const;
  virtual string basename() const;
  virtual off_t size() const;
  virtual bool isDir() const;

  virtual void sign();
  virtual string signature() const;
  virtual bool isSigned() const;

  virtual void print(ostream & os) const;

  virtual bool operator==(const DirEntry & rhs) const;
  virtual bool operator!=(const DirEntry & rhs) const;
  
 protected:
  
  string _name;
  bool _isSigned;
  string _signature;
};

#endif
