#ifndef Directory_H
#define Directory_H

#include <string>
#include <list>

#include "DirEntry.h"

class Directory: public list<DirEntry *> {

 public:

  Directory(const string name = ".", const string pattern = "*", const bool recurse = false);
  Directory(const DirEntry * d, const string pattern = "*", const bool recurse = false);

  void filter(const string pattern);
  string filter() const;

  void recurse(const bool dorecurse);
  bool recurse() const;

  bool isOk() const;
  string name() const;

  void print(ostream & os) const;

 private:

  // disallowed
  Directory(const Directory & rhs);
  void operator=(Directory & rhs);
  bool operator==(const Directory & rhs);
  bool operator!=(const Directory & rhs);
  

  void init();
  void scan();
  void reset();

  bool _isOk;
  string _name;  
  string _pattern;
  string _separator;
  bool _recurse;
};

ostream & operator<<(ostream &os, const Directory &d);

#endif
