!------------------------------------------------------------------------------
! $Id: compilerbugfixes.f90,v 1.1 1999/04/01 12:22:32 pvideler Exp $
!
! author      : P.Videler
! version     : 1.0
! description : Bug Fixes for the memory leaks for F90 intrinsics
!               TRIM ADJUSTL ADJUSTR
!
! modifications:
!               Taken From J.Bakker convert_mod.f90 (scisim) dd 14-08-97
!
!------------------------------------------------------------------------------
module compilerBugFixes
 implicit none
 private
 public ::  trim, adjustl, adjustr

 ! the following interfaces are bug fixed of both compilers:
 !     Ultra NAGWare f90 compiler Version 2.2(261)
 !     Linux NAGWare f90 compiler Version 2.2(237)

 interface trim 
    module procedure trimHere 
 end interface

 interface adjustl 
    module procedure adjustlHere 
 end interface

 interface adjustr 
    module procedure adjustrHere 
 end interface

contains

 !---------------------------------------------------------------------------

 function trimHere(c)
  character(*),	intent(IN)	:: c
  character(len_trim(c))	:: trimHere
  intrinsic trim 
  trimHere = trim(c)
 end function trimHere

 !---------------------------------------------------------------------------

 function adjustlHere(c)
  character(*),	intent(IN)	:: c
  character(len(c))		:: adjustlHere
  intrinsic adjustl 
  adjustlHere = adjustl(c)
 end function adjustlHere

 !---------------------------------------------------------------------------

 function adjustrHere(c)
  character(*),	intent(IN)	:: c
  character(len(c))		:: adjustrHere
  intrinsic adjustr 
  adjustrHere = adjustr(c)
 end function adjustrHere
 !---------------------------------------------------------------------------

end module compilerBugFixes
