//
// Giuseppe Vacanti, European Space Agency, 1999
//
#include "Directory.h"
#include <string>
#include <iostream>

int main (int argc, char * argv[]) {

  if(argc != 3){
    cerr << argv[0] << " directory pattern" << endl;
    exit(1);
  }
  Directory d(argv[1]);
  d.filter(argv[2]);

  cout << ">>Without recursion\n" << d << endl;

  d.recurse(true);
  cout << ">>With recursion\n" << d << endl;

  typedef Directory::const_iterator DI;
  
  for(DI i = d.begin(); i != d.end(); i++) {
    const DirEntry &e = **i;
    //        cout << "name " + e.name() << endl;
    //        cout << "-->basename " + e.basename() << endl;
    //        cout << "-->dirname " + e.dirname() << endl;
    cout << e.name() + " | " + e.basename() + " | " + e.dirname() << endl;
  }

}
