#include "SasDalUtils.h"
#include <Dal.h>
#include <string>
#include <iostream>

int main()
{

  using namespace SasDalUtils;

  const unsigned int nrows = 10;
  const string sample = "This is a sample string";
  vector<unsigned long> size(1);
  size[0] = sample.size();

  DataSet * set = dataSetServer->open("test.ds", Dal::Create);
  ColumnData * col = set->addTable("TEST", nrows)->addColumn("TEST", Dal::DString, "", "", size)->data();
  for(unsigned int i = 0; i < nrows; i++)
    setStringColumnRow(col, i, sample);
  dataSetServer->close(set);
  set = dataSetServer->open("test.ds", Dal::Read);
  col = set->table("TEST")->column("TEST")->data();
  for(unsigned int i = 0; i < nrows; i++)
    if(sample != getStringColumnRow(col, i)){
      cerr << "Mismatch at row " << i << endl;
      exit(-1);
    }
  dataSetServer->close(set);
}   
  
