! $Id: testaddtables.f90,v 1.5 1999/12/06 16:28:15 pvideler Exp $

program testaddtables

 use saslib
 use sasdal

 implicit none 

 type(DataSetT)   :: set
 type(TableT)     :: tbl1, tbl2
 integer(int16), pointer, dimension(:) :: p1, p2, p3, p4, p5, p7, p8 

 set = dataSet('testset.ds', create)
 tbl1 = addTable(set, 'ONE', 3, 'first table with 3 rows')
 tbl2 = addTable(set, 'TWO', 4, 'second table with 4 rows')

 p1 => int16Data(addColumn(tbl1, 'COL1', integer16)) 
 p2 => int16Data(addColumn(tbl1, 'COL2', integer16)) 
 p1 = (/ 1, 2, 3/)                                       ! sample data
 p2 = (/11,12,13/)

 p3 => int16data( addColumn(tbl2, 'COL3', integer16))    ! column order different
 p4 => int16data( addColumn(tbl2, 'COL2', integer16)) 
 p5 => int16data( addColumn(tbl2, 'COL1', integer16)) 
 p3 = (/24,25,26,27/)
 p4 = (/14,15,16,17/)
 p5 = (/ 4, 5, 6, 7/)

 call addRows(tbl1, tbl2)

 call rename(tbl1, 'ONE+TWO')     ! rename table1
 
!!$ call release(tbl2)
!!$ call deleteBlock(set, name(tbl2))    ! delete table2 from set

 ! check data
 
 p7 => int16Data(Column(tbl1, 'COL1', integer16))
 p8 => int16Data(Column(tbl1, 'COL2', integer16))

 if (notNear(p7, (/1,2,3,4,5,6,7/) ))        call error('column 1 not as expected')
 if (notNear(p8, (/11,12,13,14,15,16,17/) )) call error('column 2 not as expected')

 ! write(*,*) 'p7=', p7
 ! write(*,*) 'p8=', p8

 call release (set)

end program 
