program testevatt

  use Dal
  use eventAttributes
  use errorHandling
  implicit none

  type(DataSetT)   :: set
  type(TableT)     :: tab, tab1
  integer(int32), pointer, dimension(:) :: evattcol
  type(ColumnT) :: namecol
  integer(int32) :: i
  logical :: fail = .false.

  type EvAtt 
     character(len=32) :: name
     integer(int32)     :: value
  end type EvAtt

  type(EvAtt), dimension(0:40) :: evattTable

! Create these entries like this:
!  
! ./testevattcc  | awk '{printf("\tevattTable(%d)%%name = \"%s\"\n\tevattTable(%d)%%value = EVATT_%s\n",NR-1,$4,NR-1,$4);}'
!
        evattTable(0)%name = "BAD_E3E4"
        evattTable(0)%value = EVATT_BAD_E3E4
        evattTable(1)%name = "BAD_SHAPE"
        evattTable(1)%value = EVATT_BAD_SHAPE
        evattTable(2)%name = "BELOW_ACCEPTANCE"
        evattTable(2)%value = EVATT_BELOW_ACCEPTANCE
        evattTable(3)%name = "CLOSE_TO_BADCOL"
        evattTable(3)%value = EVATT_CLOSE_TO_BADCOL
        evattTable(4)%name = "CLOSE_TO_BADROW"
        evattTable(4)%value = EVATT_CLOSE_TO_BADROW
        evattTable(5)%name = "CLOSE_TO_BRIGHTPIX"
        evattTable(5)%value = EVATT_CLOSE_TO_BRIGHTPIX
        evattTable(6)%name = "CLOSE_TO_CCD_BORDER"
        evattTable(6)%value = EVATT_CLOSE_TO_CCD_BORDER
        evattTable(7)%name = "CLOSE_TO_CCD_WINDOW"
        evattTable(7)%value = EVATT_CLOSE_TO_CCD_WINDOW
        evattTable(8)%name = "CLOSE_TO_DEADPIX"
        evattTable(8)%value = EVATT_CLOSE_TO_DEADPIX
        evattTable(9)%name = "CLOSE_TO_FLICKERINGPIX"
        evattTable(9)%value = EVATT_CLOSE_TO_FLICKERINGPIX
        evattTable(10)%name = "CLOSE_TO_NODE_BOUNDARY"
        evattTable(10)%value = EVATT_CLOSE_TO_NODE_BOUNDARY
        evattTable(11)%name = "CLOSE_TO_ONBOARD_BADPIX"
        evattTable(11)%value = EVATT_CLOSE_TO_ONBOARD_BADPIX
        evattTable(12)%name = "COSMIC_RAY"
        evattTable(12)%value = EVATT_COSMIC_RAY
        evattTable(13)%name = "DIAGONAL"
        evattTable(13)%value = EVATT_DIAGONAL
        evattTable(14)%name = "EVLIST_LOCAL"
        evattTable(14)%value = EVATT_EVLIST_LOCAL
        evattTable(15)%name = "FLICKERING"
        evattTable(15)%value = EVATT_FLICKERING
        evattTable(16)%name = "INVALID_PATTERN"
        evattTable(16)%value = EVATT_INVALID_PATTERN
        evattTable(17)%name = "IN_BAD_FRAME"
        evattTable(17)%value = EVATT_IN_BAD_FRAME
        evattTable(18)%name = "IN_SPOILED_FRAME"
        evattTable(18)%value = EVATT_IN_SPOILED_FRAME
        evattTable(19)%name = "MIP_ASSOCIATED"
        evattTable(19)%value = EVATT_MIP_ASSOCIATED
        evattTable(20)%name = "NEXT_TO_BADPIX"
        evattTable(20)%value = EVATT_NEXT_TO_BADPIX
        evattTable(21)%name = "NEXT_TO_CCD_BORDER"
        evattTable(21)%value = EVATT_NEXT_TO_CCD_BORDER
        evattTable(22)%name = "NEXT_TO_OFFSET_COLUMN"
        evattTable(22)%value = EVATT_NEXT_TO_OFFSET_COLUMN
        evattTable(23)%name = "ONBOARD_SER"
        evattTable(23)%value = EVATT_ONBOARD_SER
        evattTable(24)%name = "ON_BADOFFSET"
        evattTable(24)%value = EVATT_ON_BADOFFSET
        evattTable(25)%name = "ON_BADPIX"
        evattTable(25)%value = EVATT_ON_BADPIX
        evattTable(26)%name = "ON_BADROW"
        evattTable(26)%value = EVATT_ON_BADROW
        evattTable(27)%name = "ON_NODE0"
        evattTable(27)%value = EVATT_ON_NODE0
        evattTable(28)%name = "ON_NODE1"
        evattTable(28)%value = EVATT_ON_NODE1
        evattTable(29)%name = "ON_NODE_INTERFACE"
        evattTable(29)%value = EVATT_ON_NODE_INTERFACE
        evattTable(30)%name = "ON_OFFSET_COLUMN"
        evattTable(30)%value = EVATT_ON_OFFSET_COLUMN
        evattTable(31)%name = "ON_WINDOW_BORDER"
        evattTable(31)%value = EVATT_ON_WINDOW_BORDER
        evattTable(32)%name = "OUTSIDE_GTI"
        evattTable(32)%value = EVATT_OUTSIDE_GTI
        evattTable(33)%name = "OUTSIDE_THRESHOLDS"
        evattTable(33)%value = EVATT_OUTSIDE_THRESHOLDS
        evattTable(34)%name = "OUT_OF_CCD_WINDOW"
        evattTable(34)%value = EVATT_OUT_OF_CCD_WINDOW
        evattTable(35)%name = "OUT_OF_FOV"
        evattTable(35)%value = EVATT_OUT_OF_FOV
        evattTable(36)%name = "REJECTED_BY_GATTI"
        evattTable(36)%value = EVATT_REJECTED_BY_GATTI
        evattTable(37)%name = "SECONDARY"
        evattTable(37)%value = EVATT_SECONDARY
        evattTable(38)%name = "TRAILING"
        evattTable(38)%value = EVATT_TRAILING
        evattTable(39)%name = "UNDERSHOOT"
        evattTable(39)%value = EVATT_UNDERSHOOT
        evattTable(40)%name = "UNKNOWN_RAWX_PATTERN"
        evattTable(40)%value = EVATT_UNKNOWN_RAWX_PATTERN


  ! create table with event attribute names
  ! also set table attributes
  set = dataSet('evatt.ds', create)
  tab = addTable(set, 'evatt', size(evattTable))
  namecol = addColumn(tab, "Attribute_Name", string, dimensions=(/32/))
  evattcol => int32Data(addColumn(tab, EVATT_COLUMN_NAME, integer32))
  do i = 0, size(evattTable)-1
     evattcol(i) = EVATT_CLEAR_ALL_FLAGS
     evattcol(i) = ior(evattcol(i), evattTable(i)%value)
     call setStringCell(namecol, i, evattTable(i)%name)
     write(*,*)"Row = ",i,"Name = ",evattTable(i)%name,"Value = ",evattTable(i)%value
     call setEventAttribute(tab,evattTable(i)%value)
  end do
  call setEmosRejectionMask(tab)
  call setEpnRejectionMask(tab)
  call setRgsRejectionMask(tab)
  
  ! SCR 198
  call setEmosSpectralMask(tab)

  ! Also write the value of the rejection mask as defined in fortran.
  ! This will be used by evatt_cxx_checks_f90 to check that the
  ! values in C++ and fortran agree.
  call setAttribute(tab, "RGS_MSK", EVATT_RGS_REJECTION_MASK)
  call setAttribute(tab, "EMOS_MSK", EVATT_EMOS_REJECTION_MASK)
  call setAttribute(tab, "EPN_MSK", EVATT_EPN_REJECTION_MASK)
  
  ! SCR 198
  call setAttribute(tab, "EMOSS_MSK", EMOS_SPECTRAL_MASK)
  
  ! propagate table attributes
  tab1 = addTable(set, 'evatt1', 0)
  call copyEventAttributes(tab,tab1)
  fail = .false.
  do i = 0, size(evattTable)-1
     if(.not. eventAttributeIsSet(tab1, evattTable(i)%value))then
        fail = .true.
        write(errStr,*)'From table does not have: ', evattTable(i)%name, evattTable(i)%value
        call message(appMsg,Silent)
     else
        write(errStr,*)'From table does have: ', evattTable(i)%name, evattTable(i)%value
        call message(appMsg,Silent)
     end if
  end do

  if(.not. (hasAttribute(tab1,'XMMEA_EM') .and. hasAttribute(tab1,'XMMEA_EP') .and. hasAttribute(tab1,'XMMEA_RG')))then
     fail = .true.
     write(errStr,*)'To table does not have all the rejection masks'
     call message(appMsg,Silent)
  end if
     
  if(fail)then
     call release(tab)
     call release(tab1)
     call release(set)
     call error('cannotFindTableAttributes')
  end if
  
  call release(tab)
  call release(tab1)
  call release(set)
 
end program testevatt
